function setcookie( name, value, expires, path, domain, secure )
  local strcookie
  local strexpires = ""
  local strpath = ""
  local strdomain = ""
  local strsecure = ""
  
  if not name or not value then
    return
  else
    strcookie = name .. "=" .. cgilua.escape( value )
  end
  
  if expires then
    local secs = date2sec( expires, "%d/%m/%Y" )
    local date = sec2date( secs, "%A, %d-%b-%Y %H:%M:%S GMT" )
    
    strexpires = "; expires=" .. date
  end
  if path then strpath = "; path=" .. path end
  if domain then strdomain = "; domain=" .. domain end
  if secure then strsecure = "; secure=" .. secure end
  
  cgilua.httpheader( "Set-Cookie: "..strcookie..strexpires..strpath..strdomain..strsecure .."\n" )
end

function setcookiehtml( name, value, expires, path, domain, secure )
  local strcookie
  local strexpires = ""
  local strpath = ""
  local strdomain = ""
  local strsecure = ""
  
  if not name or not value then
    return
  else
    strcookie = name .. "=" .. cgilua.escape( value )
  end
  
  if expires then
    local secs = date2sec( expires, "%d/%m/%Y" )
    local date = sec2date( secs, "%A, %d-%b-%Y %H:%M:%S GMT" )
    
    strexpires = "; expires=" .. date
  end
  if path then strpath = "; path=" .. path end
  if domain then strdomain = "; domain=" .. domain end
  if secure then strsecure = "; secure=" .. secure end
  
  return write( format( '<meta http-equiv="Set-Cookie" content="%s">', 
                strcookie..strexpires..strpath..strdomain..strsecure ))
end

function getcookie( name )
  local cookies = getenv( "HTTP_COOKIE" )
  
  if cookies then
    local found, _, value = strfind( cookies, ";?%s*" .. name .. "=([^;]*);?" )
    if found then return cgilua.unescape( value ) end
  end
  
  return nil
end

function deletecookie( name, path, domain )
  if not name then return end

  if cgilua.getcookie( name ) then
    local strpath = ""
    local strdomain = ""
    local strcookie = name .. "="

    if path then strpath = "; path=" .. path end
    if domain then strdomain = "; domain=" .. domain end

    local strexpires = "; expires=Thu, 01-Jan-1970 00:00:01 GMT"
    cgilua.httpheader( "Set-Cookie: "..strcookie..strexpires..strpath..strdomain.."\n" )
  else
    return
  end
end
