#include "lstate.h"

/*
** $Id: lauxlib.h,v 1.12 1999/03/10 14:19:41 roberto Exp $
** Auxiliary functions for building Lua libraries
** See Copyright Notice in lua.h
*/


#ifndef auxlib_h
#define auxlib_h


#include "lua.h"


struct luaL_reg {
  char *name;
  lua_CFunction func;
};


#define luaL_arg_check(L, cond,numarg,extramsg) if (!(cond)) \
                                               luaL_argerror(L, numarg,extramsg)

void luaL_openlib (lua_State *L, struct luaL_reg *l, int n);
void luaL_argerror (lua_State *L, int numarg, char *extramsg);
#define luaL_check_string(L, n)  (luaL_check_lstr(L, (n), NULL))
char *luaL_check_lstr (lua_State *L, int numArg, long *len);
#define luaL_opt_string(L, n, d) (luaL_opt_lstr(L, (n), (d), NULL))
char *luaL_opt_lstr (lua_State *L, int numArg, char *def, long *len);
double luaL_check_number (lua_State *L, int numArg);
#define luaL_check_int(L, n)	((int)luaL_check_number(L, n))
#define luaL_check_long(L, n)	((long)luaL_check_number(L, n))
double luaL_opt_number (lua_State *L, int numArg, double def);
#define luaL_opt_int(L, n,d)	((int)luaL_opt_number(L, n,d))
#define luaL_opt_long(L, n,d)	((long)luaL_opt_number(L, n,d))
lua_Object luaL_functionarg (lua_State *L, int arg);
lua_Object luaL_tablearg (lua_State *L, int arg);
lua_Object luaL_nonnullarg (lua_State *L, int numArg);
void luaL_verror (lua_State *L, char *fmt, ...);
char *luaL_openspace (lua_State *L, int size);
void luaL_resetbuffer (lua_State *L);
void luaL_addchar (lua_State *L, int c);
int luaL_getsize (lua_State *L);
void luaL_addsize (lua_State *L, int n);
int luaL_newbuffer (lua_State *L, int size);
void luaL_oldbuffer (lua_State *L, int old);
char *luaL_buffer (lua_State *L);
int luaL_findstring (lua_State *L, char *name, char *list[]);
void luaL_chunkid (lua_State *L, char *out, char *source, int len);
void luaL_filesource (lua_State *L, char *out, char *filename, int len);


#endif
